opencv: cv::KalmanFilter Class Reference

Public Member Functions | Public Attributes

# cv::KalmanFilter Class Reference

`#include <tracking.hpp>`

List of all members.

## Public Member Functions
CV_WRAP const Mat & | correct (const Mat &measurement)
| updates the predicted state from the measurement
void | init (int dynamParams, int measureParams, int controlParams=0, int type=CV_32F)
| re-initializes Kalman filter. The previous content is destroyed.
CV_WRAP | KalmanFilter (int dynamParams, int measureParams, int controlParams=0, int type=CV_32F)
| the full constructor taking the dimensionality of the state, of the measurement and of the control vector
CV_WRAP | KalmanFilter ()
| the default constructor
CV_WRAP const Mat & | predict (const Mat &control=Mat())
| computes predicted state
## Public Attributes
Mat | controlMatrix
| control matrix (B) (not used if there is no control)
Mat | errorCovPost
| posteriori error estimate covariance matrix (P(k)): P(k)=(I-K(k)*H)*P'(k)
Mat | errorCovPre
| priori error estimate covariance matrix (P'(k)): P'(k)=A*P(k-1)*At + Q)*/
Mat | gain
| Kalman gain matrix (K(k)): K(k)=P'(k)*Ht*inv(H*P'(k)*Ht+R)
Mat | measurementMatrix
| measurement matrix (H)
Mat | measurementNoiseCov
| measurement noise covariance matrix (R)
Mat | processNoiseCov
| process noise covariance matrix (Q)
Mat | statePost
| corrected state (x(k)): x(k)=x'(k)+K(k)*(z(k)-H*x'(k))
Mat | statePre
| predicted state (x'(k)): x(k)=A*x(k-1)+B*u(k)
Mat | temp1
Mat | temp2
Mat | temp3
Mat | temp4
Mat | temp5
Mat | transitionMatrix
| state transition matrix (A)

## Detailed Description

Kalman filter.

The class implements standard Kalman filter {http://en.wikipedia.org/wiki/Kalman_filter}. However, you can modify KalmanFilter::transitionMatrix, KalmanFilter::controlMatrix and KalmanFilter::measurementMatrix to get the extended Kalman filter functionality.

## Constructor & Destructor Documentation

CV_WRAP cv::KalmanFilter::KalmanFilter | ( | ) |

the default constructor

CV_WRAP cv::KalmanFilter::KalmanFilter | ( | int | dynamParams,
|  | int | measureParams,
|  | int | controlParams = `0`,
|  | int | type = `CV_32F`
| ) |  |

the full constructor taking the dimensionality of the state, of the measurement and of the control vector

## Member Function Documentation

CV_WRAP const Mat& cv::KalmanFilter::correct | ( | const Mat & | measurement ) |

updates the predicted state from the measurement

void cv::KalmanFilter::init | ( | int | dynamParams,
|  | int | measureParams,
|  | int | controlParams = `0`,
|  | int | type = `CV_32F`
| ) |  |

re-initializes Kalman filter. The previous content is destroyed.

CV_WRAP const Mat& cv::KalmanFilter::predict | ( | const Mat & | control = `Mat()` ) |

computes predicted state

## Member Data Documentation

Mat cv::KalmanFilter::controlMatrix

control matrix (B) (not used if there is no control)

Mat cv::KalmanFilter::errorCovPost

posteriori error estimate covariance matrix (P(k)): P(k)=(I-K(k)*H)*P'(k)

Mat cv::KalmanFilter::errorCovPre

priori error estimate covariance matrix (P'(k)): P'(k)=A*P(k-1)*At + Q)*/

Mat cv::KalmanFilter::gain

Kalman gain matrix (K(k)): K(k)=P'(k)*Ht*inv(H*P'(k)*Ht+R)

Mat cv::KalmanFilter::measurementMatrix

measurement matrix (H)

Mat cv::KalmanFilter::measurementNoiseCov

measurement noise covariance matrix (R)

Mat cv::KalmanFilter::processNoiseCov

process noise covariance matrix (Q)

Mat cv::KalmanFilter::statePost

corrected state (x(k)): x(k)=x'(k)+K(k)*(z(k)-H*x'(k))

Mat cv::KalmanFilter::statePre

predicted state (x'(k)): x(k)=A*x(k-1)+B*u(k)

Mat cv::KalmanFilter::temp1

Mat cv::KalmanFilter::temp2

Mat cv::KalmanFilter::temp3

Mat cv::KalmanFilter::temp4

Mat cv::KalmanFilter::temp5

Mat cv::KalmanFilter::transitionMatrix

state transition matrix (A)

The documentation for this class was generated from the following file:

- /usr/ports/pobj/OpenCV-2.2.0/OpenCV-2.2.0/modules/video/include/opencv2/video/tracking.hpp

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Defines